org.apache.uima.collection.metadata

## Interface CpeCasProcessor

- All Superinterfaces:
    Cloneable, MetaDataObject, Serializable, XMLizable
  All Known Subinterfaces:
    CpeIntegratedCasProcessor, CpeLocalCasProcessor, CpeRemoteCasProcessor

      public interface CpeCasProcessor
      extends MetaDataObject

  An object that holds configuration that is part of the CPE descriptor. It provides the means of configuring behavior that is common to all CasProcessor types.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addDeployParam(String aParamName, String aParamValue)` Adds deployment parameter used by the CPE when launching CasProcessor
    `String` | `getActionOnMaxError()` Returns strategy for dealing with exceeding error thresholds.
    `String` | `getActionOnMaxRestart()` Returns strategy for dealing with exceeding error thresholds.
    `int` | `getBatchSize()` Returns CasProcessor batch size
    `String` | `getCasProcessorFilter()` Returns CasProcessor filter expression.
    `CpeCheckpoint` | `getCheckpoint()` Returns `CpeCheckpoint` object containing checkpoint configuration ( checkpoint file, frequency of checkpoints )
    `CasProcessorConfigurationParameterSettings` | `getConfigurationParameterSettings()` Returns `CasProcessorConfigurationParameterSettings` object containing overrides to parameter settings for this CAS Processor.
    `CpeComponentDescriptor` | `getCpeComponentDescriptor()` Returns the `CpeComponentDescriptor` instance associated with this Cas Processor.
    `String` | `getDeployment()` Returns CasProcessor deployment type.
    `CasProcessorDeploymentParams` | `getDeploymentParams()` Returns `CasProcessorDeploymentParams` object containing deployment parameters used for launching CasProcessor.
    `String` | `getDescriptor()` Deprecated. Doesn't support the new import syntax. Use getCpeComponentDescriptor().findAbsoluteUrl() instead.
    `CasProcessorErrorHandling` | `getErrorHandling()` Returns `CasProcessorErrorHandling` object containing strategies to deal with errors that may occur during processing.
    `boolean` | `getIsParallelizable()`
    `int` | `getMaxErrorCount()` Returns the max number of errors tolerated by the CPE.
    `int` | `getMaxErrorSampleSize()` Returns sample size.
    `int` | `getMaxRestartCount()` Returns max restarts threshold fro CasProcessor
    `String` | `getName()` Returns CasProcessor's name
    `CasProcessorRunInSeperateProcess` | `getRunInSeparateProcess()`
    `String` | `getSOFA()`
    `CpeSofaMappings` | `getSofaNameMappings()`
    `int` | `getTimeout()` Returns the timeout value.
    `void` | `setActionOnMaxError(String aAction)` Sets a strategy for dealing with exceeding error thresholds.
    `void` | `setActionOnMaxRestart(String aAction)` Sets strategy for dealing with exceeding error thresholds.
    `void` | `setBatchSize(int aBatchSize)` Sets CasProcessor's batch size.
    `void` | `setCasProcessorFilter(String aFilterExpression)` Sets CasProcessor filter expression used by the CPE to route CASs.
    `void` | `setConfigurationParameterSettings(CasProcessorConfigurationParameterSettings aSettings)` Sets the `CasProcessorConfigurationParameterSettings` object containing overrides to parameter settings for this CAS Processor.
    `void` | `setCpeComponentDescriptor(CpeComponentDescriptor aDescriptor)` Sets the `CpeComponentDescriptor` instance associated with this Cas Processor.
    `void` | `setDescriptor(String aDescriptor)` Deprecated. Doesn't support the new import syntax. Use setCpeComponentDescriptor() instead.
    `void` | `setIsParallelizable(boolean isP)`
    `void` | `setMaxErrorCount(int aErrorCount)` Sets the max number of errors tolerated by the CPE.
    `void` | `setMaxErrorSampleSize(int aErrorSampleSize)` Sets the sample size.
    `void` | `setMaxRestartCount(int aErrorCount)` Sets max tolerated restarts threshold for CasProcessor
    `void` | `setName(String aName)` Sets CasProcessor's name
    `void` | `setSOFA(String aSOFA)`
    `void` | `setSofaNameMappings(CpeSofaMappings mappings)`
    `void` | `setTimeout(int aTimeoutValue)` Sets the timeout value.

    - ### Methods inherited from interface org.apache.uima.resource.metadata.MetaDataObject

      `clone, equals, getAttributeValue, getSourceUrl, getSourceUrlString, isModifiable, listAttributes, setAttributeValue, setSourceUrl`

    - ### Methods inherited from interface org.apache.uima.util.XMLizable

      `buildFromXMLElement, buildFromXMLElement, toXML, toXML, toXML, toXML`

- - ### Method Detail

    - #### setName

          void setName(String aName)
                throws CpeDescriptorException

      Sets CasProcessor's name
      Parameters:
        `aName` - - CasProcessor name
      Throws:
        `CpeDescriptorException` - tbd

    - #### getName

          String getName()

      Returns CasProcessor's name
      Returns:
        - name

    - #### setSOFA

          void setSOFA(String aSOFA)
                throws CpeDescriptorException

      Throws:
        `CpeDescriptorException`

    - #### getSOFA

          String getSOFA()

    - #### setDescriptor

          @Deprecated
          void setDescriptor(String aDescriptor)
                                  throws CpeDescriptorException

      Deprecated. Doesn't support the new import syntax. Use setCpeComponentDescriptor() instead.
      Sets CasProcessor descriptor path.
      Parameters:
        `aDescriptor` - - descriptor path
      Throws:
        `CpeDescriptorException` - tbd

    - #### getDescriptor

          @Deprecated
          String getDescriptor()

      Deprecated. Doesn't support the new import syntax. Use getCpeComponentDescriptor().findAbsoluteUrl() instead.
      Returns CasProcessor descriptor.
      Returns:
        descriptor

    - #### getCpeComponentDescriptor

          CpeComponentDescriptor getCpeComponentDescriptor()

      Returns the `CpeComponentDescriptor` instance associated with this Cas Processor. That object contains a path to the component descriptor.
      Returns:
        `CpeComponentDescriptor` instance

    - #### setCpeComponentDescriptor

          void setCpeComponentDescriptor(CpeComponentDescriptor aDescriptor)
                                  throws CpeDescriptorException

      Sets the `CpeComponentDescriptor` instance associated with this Cas Processor. That object contains a path to the component descriptor.
      Parameters:
        `aDescriptor` - `CpeComponentDescriptor` instance
      Throws:
        `CpeDescriptorException` - tbd

    - #### getDeployment

          String getDeployment()

      Returns CasProcessor deployment type. Three types are currently supported:
      - integrated
      - remote
      - local
      Returns:
        - deployment mode

    - #### setCasProcessorFilter

          void setCasProcessorFilter(String aFilterExpression)
                              throws CpeDescriptorException

      Sets CasProcessor filter expression used by the CPE to route CASs. A CasProcessor can be configured in the CPE Descriptor to use filtering using an SQL-like WHERE clause: where featurespec [ and featurespec2 ...]. The featurespec can be one of these four forms and meanings:
      - Feature Process CAS if the Feature is present (e.g. where Person)
      - Feature! Process CAS if the Feature is not present (e.g. where Person!)
      - Feature=value Process CAS if the Feature has this value( e.g. where Person=Bush)
      - Feature!=value Process CAS if the Feature does not have this value (e.g. where Person!=Bush)
      The featurespecs are implicitly connected with and operators and precedence rules are currently not supported.
      Parameters:
        `aFilterExpression` - - filter
      Throws:
        `CpeDescriptorException` - tbd

    - #### getCasProcessorFilter

          String getCasProcessorFilter()

      Returns CasProcessor filter expression. A CasProcessor can be configured in the CPE Descriptor to use filtering using an SQL-like WHERE clause: where featurespec [ and featurespec2 ...]. The featurespec can be one of these four forms and meanings:
      - Feature Process CAS if the Feature is present (e.g. where Person)
      - Feature! Process CAS if the Feature is not present (e.g. where Person!)
      - Feature=value Process CAS if the Feature has this value( e.g. where Person=Bush)
      - Feature!=value Process CAS if the Feature does not have this value (e.g. where Person!=Bush)
      The featurespecs are implicitly connected with and operators and precedence rules are currently not supported.
      Returns:
        - filter expression

    - #### setBatchSize

          void setBatchSize(int aBatchSize)

      Sets CasProcessor's batch size.
      Parameters:
        `aBatchSize` - - size of CasProcessor batch

    - #### getBatchSize

          int getBatchSize()

      Returns CasProcessor batch size
      Returns:
        - batch size

    - #### getErrorHandling

          CasProcessorErrorHandling getErrorHandling()

      Returns `CasProcessorErrorHandling` object containing strategies to deal with errors that may occur during processing. This object provides the means of modifying error thresholds and actions to take when error thresholds are exceeded.
      Returns:
        `CasProcessorErrorHandling`

    - #### getCheckpoint

          CpeCheckpoint getCheckpoint()

      Returns `CpeCheckpoint` object containing checkpoint configuration ( checkpoint file, frequency of checkpoints )
      Returns:
        `CasProcessorErrorHandling`

    - #### getDeploymentParams

          CasProcessorDeploymentParams getDeploymentParams()

      Returns `CasProcessorDeploymentParams` object containing deployment parameters used for launching CasProcessor. This object provides the means of adding, getting, and removing `CasProcessorDeploymentParam` objects.
      Returns:
        - object containing list of `CasProcessorDeploymentParam`

    - #### setMaxErrorCount

          void setMaxErrorCount(int aErrorCount)

      Sets the max number of errors tolerated by the CPE. If the the threshold is exceeded the CPE will take an action based on defined strategy. Max Error is defined in terms of a quotient, like 3/1000. Where 3 is the actual max error tolerance and 1000 is a sample size. So the above is interpreted as 3 errors per thousand entities processed.
      Parameters:
        `aErrorCount` - - max error threshold

    - #### getMaxErrorCount

          int getMaxErrorCount()

      Returns the max number of errors tolerated by the CPE. If the the threshold is exceeded the CPE will take an action based on defined strategy. Max Error is defined in terms of a quotient, like 3/1000. Where 3 is the actual max error tolerance and 1000 is a sample size. So the above is interpreted as 3 errors per thousand entities processed.
      Returns:
        - max error threshold

    - #### setMaxErrorSampleSize

          void setMaxErrorSampleSize(int aErrorSampleSize)

      Sets the sample size. Max Error is defined in terms of a quotient, like 3/1000. Where 3 is the actual max error tolerance and 1000 is a sample size. So the above is interpreted as 3 errors per thousand entities processed.
      Parameters:
        `aErrorSampleSize` - the sample size

    - #### getMaxErrorSampleSize

          int getMaxErrorSampleSize()

      Returns sample size. Max Error is defined in terms of a quotient, like 3/1000. Where 3 is the actual max error tolerance and 1000 is a sample size. So the above is interpreted as 3 errors per thousand entities processed.
      Returns:
        - sample size

    - #### setActionOnMaxError

          void setActionOnMaxError(String aAction)

      Sets a strategy for dealing with exceeding error thresholds. The three supported strategies are:
      - terminate - termines the CPE
      - continue - continue despite the error
      - disable - disable CasProcessor
      Parameters:
        `aAction` - - action to take

    - #### getActionOnMaxError

          String getActionOnMaxError()

      Returns strategy for dealing with exceeding error thresholds. The three supported strategies are:
      - terminate - termines the CPE
      - continue - continue despite the error
      - disable - disable CasProcessor
      Returns:
        - action to take

    - #### setMaxRestartCount

          void setMaxRestartCount(int aErrorCount)

      Sets max tolerated restarts threshold for CasProcessor
      Parameters:
        `aErrorCount` - - max restart count

    - #### getMaxRestartCount

          int getMaxRestartCount()

      Returns max restarts threshold fro CasProcessor
      Returns:
        - max restart count

    - #### setActionOnMaxRestart

          void setActionOnMaxRestart(String aAction)

      Sets strategy for dealing with exceeding error thresholds. The three supported strategies are:
      - terminate - termines the CPE
      - continue - continue despite the error
      - disable - disable CasProcessor
      Parameters:
        `aAction` - - action to take

    - #### getActionOnMaxRestart

          String getActionOnMaxRestart()

      Returns strategy for dealing with exceeding error thresholds. The three supported strategies are:
      - terminate - termines the CPE
      - continue - continue despite the error
      - disable - disable CasProcessor
      Returns:
        the action to take when the error threshold is exceeded

    - #### setTimeout

          void setTimeout(int aTimeoutValue)

      Sets the timeout value. The amount of time the CPE will wait for response from CasProcessor
      Parameters:
        `aTimeoutValue` - - timeout value

    - #### getTimeout

          int getTimeout()

      Returns the timeout value. The amount of time the CPE will wait for response from CasProcessor
      Returns:
        - timeout value

    - #### addDeployParam

          void addDeployParam(String aParamName,
                              String aParamValue)
                       throws CpeDescriptorException

      Adds deployment parameter used by the CPE when launching CasProcessor
      Parameters:
        `aParamName` - - param name
        `aParamValue` - - param value
      Throws:
        `CpeDescriptorException` - tbd

    - #### getConfigurationParameterSettings

          CasProcessorConfigurationParameterSettings getConfigurationParameterSettings()

      Returns `CasProcessorConfigurationParameterSettings` object containing overrides to parameter settings for this CAS Processor.
      Returns:
        - object containing parameter setting overrides

    - #### setConfigurationParameterSettings

          void setConfigurationParameterSettings(CasProcessorConfigurationParameterSettings aSettings)
                                          throws CpeDescriptorException

      Sets the `CasProcessorConfigurationParameterSettings` object containing overrides to parameter settings for this CAS Processor.
      Parameters:
        `aSettings` - object containing parameter setting overrides
      Throws:
        `CpeDescriptorException` - tbd

    - #### getSofaNameMappings

          CpeSofaMappings getSofaNameMappings()

    - #### setSofaNameMappings

          void setSofaNameMappings(CpeSofaMappings mappings)

      Parameters:
        `mappings` - -

    - #### getRunInSeparateProcess

          CasProcessorRunInSeperateProcess getRunInSeparateProcess()

    - #### setIsParallelizable

          void setIsParallelizable(boolean isP)

    - #### getIsParallelizable

          boolean getIsParallelizable()

Copyright © 2006–2021 The Apache Software Foundation. All rights reserved.